from datetime import datetime, timezone

from bot_api.abc.transformer_abc import TransformerABC
from bot_api.model.auth_user_dto import AuthUserDTO
from bot_data.model.auth_role_enum import AuthRoleEnum
from bot_data.model.auth_user import AuthUser


class AuthUserTransformer(TransformerABC):

    @staticmethod
    def to_db(dto: AuthUserDTO) -> AuthUser:
        return AuthUser(
            dto.first_name,
            dto.last_name,
            dto.email,
            dto.password,
            None,
            None,
            None,
            None,
            None,
            datetime.now(),
            AuthRoleEnum.normal if dto.auth_role is None else AuthRoleEnum(dto.auth_role),
            auth_user_id=0 if dto.id is None else dto.id
        )

    @staticmethod
    def to_dto(db: AuthUser, password: str = None) -> AuthUserDTO:
        return AuthUserDTO(
            db.id,
            db.first_name,
            db.last_name,
            db.email,
            '' if password is None else password,
            db.confirmation_id,
            db.auth_role
        )
